	.file	"combine.c"
	.text
.globl combine
	.type	combine, @function
combine:
.LFB2:
	pushq	%rbp
.LCFI0:
	movq	%rsp, %rbp
.LCFI1:
	movq	%rdi, -8(%rbp)
	movl	%esi, -12(%rbp)
	movq	%rdx, -24(%rbp)
	movl	$0, -32(%rbp)
	movl	$0, -28(%rbp)
.L2:
	movl	-28(%rbp), %eax
	cmpl	-12(%rbp), %eax
	jge	.L3
	movl	-28(%rbp), %eax
	cltq
	leaq	0(,%rax,4), %rdx
	movq	-8(%rbp), %rax
	movl	(%rdx,%rax), %edx
	leaq	-32(%rbp), %rax
	addl	%edx, (%rax)
	leaq	-28(%rbp), %rax
	incl	(%rax)
	jmp	.L2
.L3:
	movq	-24(%rbp), %rdx
	movl	-32(%rbp), %eax
	movl	%eax, (%rdx)
	leave
	ret
.LFE2:
	.size	combine, .-combine
.globl combine_step2
	.type	combine_step2, @function
combine_step2:
.LFB3:
	pushq	%rbp
.LCFI2:
	movq	%rsp, %rbp
.LCFI3:
	movq	%rdi, -8(%rbp)
	movl	%esi, -12(%rbp)
	movq	%rdx, -24(%rbp)
	movl	$1, -32(%rbp)
	movl	$1, -36(%rbp)
	movl	-12(%rbp), %eax
	decl	%eax
	movl	%eax, -40(%rbp)
	movl	$0, -28(%rbp)
.L6:
	movl	-28(%rbp), %eax
	cmpl	-40(%rbp), %eax
	jge	.L9
	movl	-28(%rbp), %eax
	cltq
	leaq	0(,%rax,4), %rcx
	movq	-8(%rbp), %rdx
	movl	-32(%rbp), %eax
	imull	(%rcx,%rdx), %eax
	movl	%eax, -32(%rbp)
	movl	-28(%rbp), %eax
	cltq
	salq	$2, %rax
	addq	-8(%rbp), %rax
	leaq	4(%rax), %rdx
	movl	-36(%rbp), %eax
	imull	(%rdx), %eax
	movl	%eax, -36(%rbp)
	leaq	-28(%rbp), %rax
	addl	$2, (%rax)
	jmp	.L6
.L9:
	movl	-28(%rbp), %eax
	cmpl	-12(%rbp), %eax
	jge	.L10
	movl	-28(%rbp), %eax
	cltq
	leaq	0(,%rax,4), %rcx
	movq	-8(%rbp), %rdx
	movl	-32(%rbp), %eax
	imull	(%rcx,%rdx), %eax
	movl	%eax, -32(%rbp)
	leaq	-28(%rbp), %rax
	incl	(%rax)
	jmp	.L9
.L10:
	movq	-24(%rbp), %rax
	movl	-32(%rbp), %edx
	imull	-36(%rbp), %edx
	movl	%edx, (%rax)
	leave
	ret
.LFE3:
	.size	combine_step2, .-combine_step2
	.section	.eh_frame,"a",@progbits
.Lframe1:
	.long	.LECIE1-.LSCIE1
.LSCIE1:
	.long	0x0
	.byte	0x1
	.string	""
	.uleb128 0x1
	.sleb128 -8
	.byte	0x10
	.byte	0xc
	.uleb128 0x7
	.uleb128 0x8
	.byte	0x90
	.uleb128 0x1
	.align 8
.LECIE1:
.LSFDE1:
	.long	.LEFDE1-.LASFDE1
.LASFDE1:
	.long	.LASFDE1-.Lframe1
	.quad	.LFB2
	.quad	.LFE2-.LFB2
	.byte	0x4
	.long	.LCFI0-.LFB2
	.byte	0xe
	.uleb128 0x10
	.byte	0x86
	.uleb128 0x2
	.byte	0x4
	.long	.LCFI1-.LCFI0
	.byte	0xd
	.uleb128 0x6
	.align 8
.LEFDE1:
.LSFDE3:
	.long	.LEFDE3-.LASFDE3
.LASFDE3:
	.long	.LASFDE3-.Lframe1
	.quad	.LFB3
	.quad	.LFE3-.LFB3
	.byte	0x4
	.long	.LCFI2-.LFB3
	.byte	0xe
	.uleb128 0x10
	.byte	0x86
	.uleb128 0x2
	.byte	0x4
	.long	.LCFI3-.LCFI2
	.byte	0xd
	.uleb128 0x6
	.align 8
.LEFDE3:
	.section	.note.GNU-stack,"",@progbits
	.ident	"GCC: (GNU) 3.4.2 20041017 (Red Hat 3.4.2-6.fc3)"
